import React from 'react';
import { AutoComplete, Icon, Button, Input, InputNumber, Select, Spin, Table, message, Modal, Row, Col, DatePicker,Switch,Upload} from 'antd';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import moment from 'moment';
import './myClient.less';
import { orderStatusList,cityArr,customerStatus } from '../../dataDic.js';
import { beforeUploadFile,getOrderStatus, getSearchUrl,getcustomerTyp,getcityArr,getcustomerStatue,getCompanyIntention,getfllowSituation,getsex} from '../../tools.js';

const data = [{
		  companyName   : '公司名称',
		  _followSituation : 'John Brown',
		  _companyIntention: 32,
		  
		}, {
		  companyName: '跟单人',
		  _followSituation: 'Jim Green',
		  _companyIntention: 42,	 
		}, {
		  companyName: '时间',
		  _followSituation: 'Joe Black',
		  _companyIntention: 32,
		 
	}];
const AchievementDetail = React.createClass({
    getInitialState () {
        return {
            visible: false,
            loading: false,
            dataSource: [],
        };
    },
    loadLogs (id) {   	
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/portal/order/achievementOrderLog",
            data: {
                id:id
            },
            success: function (data) {          	
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.length; i++) {
                        let thisdata = data.data[i];
                        theArr.push({
                            key: i,
                            recordTime: thisdata.recordTime,
                            status: thisdata.status,
                            comment: thisdata.comment,
                            operator: thisdata.operator,
                            recordTimeFormattedDate: thisdata.recordTimeFormattedDate                //传回来的值           可能要改
                        });
                    };
                };
                this.setState({
                    dataSource: theArr
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    handleSubmit (e) {
        this.setState({
            loading: true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/portal/order/updateAchievementOrder',
            data: {
                id: this.props.data.id,
            }
        }).done(function (data) {
            this.setState({
                loading: false
            });
            if (!data.error.length) {
                message.success('领取成功！');
                this.handleOk();
            } else {
                message.warning(data.error[0].message);
            };
        }.bind(this));
    },
    handleCancel (e) {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false);
    },
    handleOk (e) {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false, true);
    },
    componentWillReceiveProps (nextProps) {
        if (!this.state.visible && nextProps.showDesc && nextProps.data) {
            this.loadLogs(nextProps.data.id);
            this.state.paymentId = nextProps.data.paymentId;
            this.state.paymentType = nextProps.data.paymentType;
            this.state.paymentValue = nextProps.data.paymentValue;
            this.state.transferPrice = nextProps.data.transferPrice;
            this.state.orderStatus = undefined;
            this.state.comment = undefined;
            this.state.recordTime = undefined;
        };
        this.state.visible = nextProps.showDesc;
    },
    render () {       
    	 const theData = this.props.data || {};    
            return (
                <div className="patent-desc">
                    <Modal maskClosable={false} visible={this.state.visible}
                        onOk={this.checkPatentProcess} onCancel={this.handleCancel}
                        width='800px'
                        footer={null}
                        title="客户详情"
                        className="demand-order-content">
                        <Spin spinning={this.state.loading}>                        	
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>客户类型：</Col>
                                <Col span={10}>{getcustomerTyp(theData.customerTyp)}</Col>
                                <Col span={3}>编号：</Col>
                                <Col span={10}>{theData.id}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>录入时间：</Col>
                                <Col span={10}>{theData.createTime}</Col>
                                <Col span={3}>跟单人：</Col>
                                <Col span={10}>{theData.ownerId}</Col>
                            </Row>
                            <Row style={{marginLeft:'50px'}}>基本资料:</Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>公司名称：</Col>
                                <Col span={10}>{theData.companyName}</Col>
                                <Col span={3}>公司行业：</Col>
                                <Col span={10}>{theData.companyIndustry}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>意向服务：</Col>
                                <Col span={10}>{getCompanyIntention(theData.companyIntention)}</Col>
                                <Col span={3}>地区：</Col>
                                <Col span={10}>{getcityArr(theData.province)}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>最新跟进：</Col>
                                <Col span={10}>{getfllowSituation(theData.followSituation)}</Col>
                                <Col span={3}>客户状态：</Col>
                                <Col span={10}>{getcustomerStatue(theData.customerStatus)}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>详细地址：</Col>                                
                                <Col span={10}>{theData.adress}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>   
                                <Col span={3}>备注：</Col>
                                <Col span={10}>{theData.remark}</Col>
                            </Row>
                            <Row style={{marginLeft:'50px'}}>联系资料:</Row>
                            <Row style={{marginLeft:'100px'}}> 
                                <Col span={3}>姓名：</Col>
                                <Col span={10}>{theData.contactName}</Col>
                                <Col span={3}>性别：</Col>
                                <Col span={10}>{getsex(theData.sex)}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>手机号码：</Col>
                                <Col span={10}>{theData.telNum}</Col>
                                <Col span={3}>座机号：</Col>
                                <Col span={10}>{theData.mobile}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>QQ号码：</Col>
                                <Col span={10}>{theData.qq}</Col>
                                <Col span={3}>邮箱号：</Col>
                                <Col span={10}>{theData.email}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}>微信：</Col>                                
                                <Col span={10}>{theData.wechat}</Col>
                                <Col span={3}>部门：</Col>
                                <Col span={10}>{theData.department}</Col>
                            </Row>
                            <Row style={{marginLeft:'100px'}}> 
                                <Col span={3}>职位：</Col>
                                <Col span={10}>{theData.customerPosition}</Col>
                            </Row>                               
                            <Row style={{marginLeft:'100px'}}>
                                <Col span={3}></Col>
                                <Col span={20}>
                                    <Button style={{ marginRight: '20px' }} type="primary" onClick={this.handleSubmit}>领取</Button>                                    
                                    <Button className="set-submit" type="ghost" onClick={this.handleCancel}>取消</Button>
                                </Col>
                            </Row>
                        </Spin>
                    </Modal>
                </div>
            );
    },
});

//查询功能和初始列表
const AchievementOrderList = React.createClass({
    loadData(pageNo, apiUrl) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,          
            url:globalConfig.context + '/api/admin/customer/searchCustomerList',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,               
                companyName: this.state.companyName, //名称
				customerTyp: this.state.customerTyp, //客户类型
              	province:this.state.province,//地区
				customerStatus:this.state.customerStatus,//客户状态1
				contactName:this.state.contactName,//联系人姓名1
				adminName:this.state.adminName,//跟单人1
				companyIntention:this.state.companyIntention,//意向服务1
				followSituation:this.state.followSituation,//跟进进度1
            },
            success: function (data) {            	
                let theArr = [];
                if (!data.data || !data.data.list) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };                   
                } else {                	
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];                       
                        theArr.push({
                            key: i,
                            id: thisdata.id,
                            companyName:thisdata.companyName,
                            customerTyp:thisdata.customerTyp,
                            province:thisdata.province,
                            contactName:thisdata.contactName,
                            telNum:thisdata.telNum,
                            customerStatus:thisdata.customerStatus,
                            companyIntention:thisdata.companyIntention,
                            followSituation:thisdata.followSituation,
                            adminName:thisdata.adminName                                                                                       
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };               
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },   
    getInitialState() {
        return {
            searchMore: true,
            searchType: 0,
            validityPeriodDate: [],
            releaseDate: [],
            selectedRowKeys: [],
            selectedRows: [],
            loading: false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [               
                {
                    title: '公司名称',
                    dataIndex: 'companyName',
                    key: 'companyName',
                }, {
                    title: '客户类型',
                    dataIndex: 'customerTyp',
                    key: 'customerTyp',
                    render: text => { return getcustomerTyp(text); }
                }, {
                    title: '地区',
                    dataIndex: 'province',
                    key: 'province',
                    render: text => { return getcityArr(text); }
                }, {
                    title: '联系人姓名',
                    dataIndex: 'contactName',
                    key: 'contactName',                    
                }, 
                {
                    title: '手机号',
                    dataIndex: 'telNum',
                    key:'telNum',                   
                },
                 {
                    title: '客户状态',
                    dataIndex: 'customerStatus',
                    key: 'customerStatus',
                    render: text => { return getcustomerStatue(text) }
                },
                {
                    title: '意向服务',
                    dataIndex: 'companyIntention',
                    key: 'companyIntention',
                    render: text => { return getCompanyIntention(text) }
                },
                 {
                    title: '最新跟进',
                    dataIndex: 'followSituation',
                    key: 'followSituation',
                    render: text => { return getfllowSituation(text) }
                },
                 {
                    title: '跟单人',
                    dataIndex: 'adminName',
                    key: 'adminName',
                }
            ],
            dataSource: [],
            searchTime: [],
        };
    },
    componentWillMount() {
        let theArr = [];
        customerStatus.map(function (item) {
            theArr.push(
                <Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
            )
        });
        let auditArr = [];
        cityArr.map(function (item) {
            auditArr.push(
                <Select.Option value={item.value} key={item.key}>{item.key}</Select.Option>
            )
        });       
        this.state.customerStatuarr = theArr;
        this.state.auditStatusOption = auditArr;
        if (window.location.search) {
            let theObj = getSearchUrl(window.location.search);
            if (theObj.rid) {
                theObj.id = theObj.rid;
                if (theObj.rid != 'null') {
                    this.tableRowClick(theObj);
                };
            };
        };       
        this.loadData();        
    },
    tableRowClick(record, index) {
        this.state.RowData = record;
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    search() {
        this.loadData();
    },
    reset() {
        this.state.id = undefined;
        this.state.companyName = undefined;
        this.state.customerTyp = undefined;
        this.state.province = undefined;
        this.state.ownerType = undefined;
        this.state.customerStatus = undefined;
        this.state.auditStatus = undefined;
        this.state.ownerId = undefined;
        this.state.contactName = undefined;  
        this.state.releaseDate = [];
        this.loadData(); 
    },
    searchSwitch() {
        this.setState({
            searchMore: !this.state.searchMore
        });
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
                this.setState({
                    selectedRows: selectedRows.slice(-1),
                    selectedRowKeys: selectedRowKeys.slice(-1)
                });
            }
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return (
            <div className="user-content" >
                <div className="content-title">                  
                    <span>公共客户管理</span>                  
                </div>
                <div className="user-search">                    
                    <Input placeholder="公司名称"
                        value={this.state.customerName}
                        onChange={(e) => { this.setState({ customerName: e.target.value }); }} /> 
                    <Select placeholder="客户类型" style={{ width: 120 }}
                            value={this.state.shareTyp }
                            onChange={(e) => { this.setState({ shareTyp : e }) }}>
                            <Select.Option value="0" >个人客户</Select.Option>
                            <Select.Option value="1" >公司客户</Select.Option>
                    </Select>     
                    <Select placeholder="意向服务"
                            style={{ width: 160 }}
                            value={this.state.companyIntention}
                            onChange={(e) => { this.setState({ companyIntention: e }) }}>
                            {this.state.intentionalOption}
                    </Select>
                    <Select placeholder="跟进进度"
                            style={{ width: 160 }}
                            value={this.state.followSituation}
                            onChange={(e) => { this.setState({ followSituation: e }) }}>
                            {this.state.newOption}
                    </Select>
                    <Select placeholder="地区"
                            style={{ width: 160 }}
                            value={this.state.province}
                            onChange={(e) => { this.setState({ province: e }) }}>
                            {this.state.auditStatusOption}
                    </Select>
                    <Select placeholder="客户状态" style={{ width: 120 }}
                            value={this.state.customerStatus}
                            onChange={(e) => { this.setState({ customerStatus: e }) }}>                           
                            {this.state.customerStatuarr}
                    </Select>
                    <Button type="primary" onClick={this.search}>搜索</Button>
                    <Button onClick={this.reset}>重置</Button>                                                       
                    <span>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>
                    <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>
                    	<Input placeholder="跟单人" style={{width:'140px',marginRight:'10px'}}
		                    value={this.state.ownerId}
		                    onChange={(e) => { this.setState({ ownerId: e.target.value }); }} />
		                <Input placeholder="联系人姓名" style={{width:'140px',marginRight:'10px'}}
		                    value={this.state.contactName}
		                    onChange={(e) => { this.setState({ contactName: e.target.value }); }} />                                        	
                        <span>发布时间 :</span>
                        <RangePicker
                            value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
                            this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
                            onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} />                            
                    </div>
                </div>
                <div className="patent-table">
                    <Spin spinning={this.state.loading}>
                        <Table columns={this.state.columns}
                            dataSource={this.state.dataSource}
                            rowSelection={rowSelection}
                            pagination={this.state.pagination}
                            onRowClick={this.tableRowClick} />
                    </Spin>
                </div>
                <AchievementDetail
                    data={this.state.RowData}
                    showDesc={this.state.showDesc}
                    closeDesc={this.closeDesc} />
            </div >
        );
    }
});

export default AchievementOrderList;
